<?php
/*
  $Id: html_output.php,v 1.3 2005/08/18 13:06:44 mwithington Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

  // --------------------------------------------------------------------------------------------------------------
  // create a self reference to the a osCommerce module
  function modSefRef ( $osModName = null ) {
    global $osMod;
    if ( !$osModName ) { $osModName = $osMod; };
    return $osModName . '.php';
  }; // modSefRef

  // --------------------------------------------------------------------------------------------------------------
  // remove parameters from a request url
  function remove_param( $param_str, $remove ) {
    $param_str = preg_replace( '/\&|\?/', "{SEP}", $param_str );
    $param_arr = split( '{SEP}', $param_str );
    $final_val = null;
    foreach ( $param_arr as $param ) {
      $pass = 1;
      foreach ( $remove as $key ) {
        if ( preg_match( "/^$key/", $param ) ) { $pass = 0; break; }
      }
      if ( $pass ) { $final_val .= $param . '&'; };
    }
    $final_val = preg_replace( '/\&+$/', '', $final_val );
    return $final_val;
  }; // remove_params

  // --------------------------------------------------------------------------------------------------------------
  // The HTML href link wrapper function
  function tep_href_link($page = '', $parameters = '', $connection = 'NONSSL', $add_session_id = true, $search_engine_safe = true) {
  global $kill_sid, $_GET;
    global $request_type, $session_started, $SID;

    if (!tep_not_null($page)) {
      die('</td></tr></table></td></tr></table><br><br><font color="#ff0000"><b>Error!</b></font><br><br><b>Unable to determine the page link!<br><br>');
    }
if ($_GET['language'] && $kill_sid) {
      $l = ereg('[&\?/]?language[=/][a-z][a-z]', $parameters, $m);
      if ($l) {
        $parameters = ereg_replace("[&\?/]?language[=/][a-z][a-z]", "", $parameters);
        $_GET['language'] = substr($m[0],-2);
      }
      if (tep_not_null($parameters)) {
        $parameters .= "&language=" . $_GET['language'];
      } else {
        $parameters = "language=" . $_GET['language'];
      }
    }
    if ($connection == 'NONSSL') {
      $link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
    } elseif ($connection == 'SSL') {
      if (ENABLE_SSL == true) {
        $link = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG;
      } else {
        $link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
      }
    } else {
      die('</td></tr></table></td></tr></table><br><br><font color="#ff0000"><b>Error!</b></font><br><br><b>Unable to determine connection method on a link!<br><br>Known methods: NONSSL SSL</b><br><br>');
    }

    // -- webMS Modification --
    $page_id = preg_replace( '/\.php/', '', $page);
    if ( preg_match( '/popup/', $page_id ) || preg_match( '/popup/', $parameters ) ) {
      $page_ud = preg_replace( '/^[\w_]+\./', 'index2.', $page);
      $dosefecd = 'false';
    } else {
      $page_ud = preg_replace( '/^[\w_]+\./', 'index.', $page);
      $dosefecd = 'true';
    }
    $link .= $page_ud;
    $parameters = remove_param( $parameters, array('option','osMod','osCsid') );

    // Debug Line
    // echo "PAGE[ $page ] PAGE_ID [ $page_id ] PAGE_UD [ $page_id ] LINK [ $link ] PARAMETERS [ $parameters ]";

    if ( $parameters != 'NONE' ) {
      if (preg_match('/\?/',$page)){
        if ($parameters == '') {
          $link .= '&option=com_oscommerce&osMod=' . $page_id;
        } else {
          $link .= '&option=com_oscommerce&osMod=' . $page_id  . '&' . $parameters  ;
        }
      } else {
        if ($parameters == '') {
          $link .= '?option=com_oscommerce&osMod=' . $page_id;
        } else {
          $link .= '?option=com_oscommerce&osMod=' . $page_id . '&' . $parameters ;
        }
      }
    }
    $separator = '&';

    while ( (substr($link, -1) == '&') || (substr($link, -1) == '?') ) $link = substr($link, 0, -1);

    // Add the session ID when moving from different HTTP and HTTPS servers, or when SID is defined
    if ( ($add_session_id == true) && ($session_started == true) && (SESSION_FORCE_COOKIE_USE == 'False') ) {
      if (tep_not_null($SID)) {
        $_sid = $SID;
      } elseif ( ( ($request_type == 'NONSSL') && ($connection == 'SSL') && (ENABLE_SSL == true) ) || ( ($request_type == 'SSL') && ($connection == 'NONSSL') ) ) {
        if (HTTP_COOKIE_DOMAIN != HTTPS_COOKIE_DOMAIN) {
          $_sid = tep_session_name() . '=' . tep_session_id();
        }
      }
    }
if (isset($_sid) && ( !$kill_sid ) ) {
      //$link .= $separator . tep_output_string($_sid);
    }
    if ( (SEARCH_ENGINE_FRIENDLY_URLS == 'true') && ($search_engine_safe == true)) {
		global $mosConfig_live_site;
		if (eregi('index.php',$link)) {
			$link = str_replace($mosConfig_live_site.'/', '', $link);
		}
      $link = sefRelToAbs($link);
    }



    // Debug Line
    // echo " RETURN [ $link ][ $_sid ] <br/>";

    return $link;
  }

  // --------------------------------------------------------------------------------------------------------------
  // The HTML image wrapper function
  function tep_image($src, $alt = '', $width = '', $height = '', $parameters = '') {
    if ( (empty($src) || ($src == DIR_WS_IMAGES)) && (IMAGE_REQUIRED == 'false') ) {
      return false;
    }

// alt is added to the img tag even if it is null to prevent browsers from outputting
// the image filename as default
    $image = '<img src="' . tep_output_string($src) . '" border="0" alt="' . tep_output_string($alt) . '"';

    if (tep_not_null($alt)) {
      $image .= ' title=" ' . tep_output_string($alt) . ' "';
    }

    if ( (CONFIG_CALCULATE_IMAGE_SIZE == 'true') && (empty($width) || empty($height)) ) {
      if ($image_size = @getimagesize($src)) {
        if (empty($width) && tep_not_null($height)) {
          $ratio = $height / $image_size[1];
          $width = $image_size[0] * $ratio;
        } elseif (tep_not_null($width) && empty($height)) {
          $ratio = $width / $image_size[0];
          $height = $image_size[1] * $ratio;
        } elseif (empty($width) && empty($height)) {
          $width = $image_size[0];
          $height = $image_size[1];
        }
      } elseif (IMAGE_REQUIRED == 'false') {
        return false;
      }
    }

    if (tep_not_null($width) && tep_not_null($height)) {
      $image .= ' width="' . tep_output_string($width) . '" height="' . tep_output_string($height) . '"';
    }

    if (tep_not_null($parameters)) $image .= ' ' . $parameters;

    $image .= '>';

    return $image;
  }

  // --------------------------------------------------------------------------------------------------------------
  // The HTML form submit button wrapper function
 // BEGIN: CSS Buttons Everywhere
function tep_image_submit($image, $value = '-AltValue-', $parameters = '') {
	global $language;
	$css_submit = '<input type="submit" style="cursor: hand;" class="Button" value="' . tep_output_string($value) . '" />';
	return $css_submit;
}
// END: CSS Buttons Everywhere

  // --------------------------------------------------------------------------------------------------------------

  // The HTML form submit button wrapper function
 // BEGIN: CSS Buttons Everywhere
function tep_image_submit_GV($image, $value = '-AltValue-', $parameters = '', $clickaction) {
	global $language;
	$css_submit = '<input type="button" class="Button" value="' . tep_output_string($value) . '" onclick="'.$clickaction.'" style="cursor: hand;"/>';
	return $css_submit;
}
// END: CSS Buttons Everywhere

  // --------------------------------------------------------------------------------------------------------------
  // Output a function button in the selected language
  // BEGIN: CSS Buttons Everywhere
function tep_image_button($image, $value = '-AltValue-', $parameters = '') {
	global $language;
	$image = '<div class="Button" style="cursor: hand; ">&nbsp;' . tep_output_string($value) . '&nbsp;</div>';

	return $image;
}
// END: CSS Buttons Everywhere

// V1.1.7 Button Upgrade
function tep_image_submit_ECJ($image, $value = '-AltValue-', $parameters
= '', $clickaction) {
	global $language;
	$css_submit = '<input type="button" class="Button" value="' .
tep_output_string($value) . '"
onclick="window.location=\''.$clickaction.'\'" style="cursor: hand;"/>';
	return $css_submit;
}
//End V1.1.7 Button Upgrade

  // --------------------------------------------------------------------------------------------------------------
  // Output a separator either through whitespace, or with an image
  function tep_draw_separator($image = 'pixel_black.gif', $width = '100%', $height = '1') {
    return tep_image(DIR_WS_IMAGES . $image, '', $width, $height);
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a form
  function tep_draw_form($name, $action, $method = 'post', $parameters = '') {
    $action_url = preg_replace( '/\?.*/','',$action);
    $action_par = preg_replace( '/.*\?/','',$action);

    $form = '<form name="' . tep_output_string($name) . '" action="' . tep_output_string($action_url) . '" method="' . tep_output_string($method) . '"';

    if (tep_not_null($parameters)) $form .= ' ' . $parameters;

    $form .= '>';

    if ($action_par != '') {
      $action_params = array();
      $action_params = split('&',$action_par);
      foreach ($action_params AS $this_par) {
        list($key, $value) = split('=',$this_par);
        $form .= tep_draw_hidden_field( $key, $value );
      };
    }

    return $form;
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a form input field
  function tep_draw_input_field($name, $value = '', $parameters = '', $type = 'text', $reinsert_value = true) {
    $field = '<input type="' . tep_output_string($type) . '" name="' . tep_output_string($name) . '"';

    if ( (isset($GLOBALS[$name])) && ($reinsert_value == true) ) {
      $field .= ' value="' . tep_output_string(stripslashes($GLOBALS[$name])) . '"';
    } elseif (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    }

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    return $field;
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a form password field
  function tep_draw_password_field($name, $value = '', $parameters = 'maxlength="40"') {
    return tep_draw_input_field($name, $value, $parameters, 'password', false);
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a selection field - alias function for tep_draw_checkbox_field() and tep_draw_radio_field()
  function tep_draw_selection_field($name, $type, $value = '', $checked = false, $parameters = '') {
    $selection = '<input type="' . tep_output_string($type) . '" name="' . tep_output_string($name) . '"';

    if (tep_not_null($value)) $selection .= ' value="' . tep_output_string($value) . '"';

    if ( ($checked == true) || ( isset($GLOBALS[$name]) && is_string($GLOBALS[$name]) && ( ($GLOBALS[$name] == 'on') || (isset($value) && (stripslashes($GLOBALS[$name]) == $value)) ) ) ) {
      $selection .= ' CHECKED';
    }

    if (tep_not_null($parameters)) $selection .= ' ' . $parameters;

    $selection .= '>';

    return $selection;
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a form checkbox field
  function tep_draw_checkbox_field($name, $value = '', $checked = false, $parameters = '') {
    return tep_draw_selection_field($name, 'checkbox', $value, $checked, $parameters);
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a form radio field
  function tep_draw_radio_field($name, $value = '', $checked = false, $parameters = '') {
    return tep_draw_selection_field($name, 'radio', $value, $checked, $parameters);
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a form textarea field
  function tep_draw_textarea_field($name, $wrap, $width, $height, $text = '', $parameters = '', $reinsert_value = true) {
    $field = '<textarea name="' . tep_output_string($name) . '" wrap="' . tep_output_string($wrap) . '" cols="' . tep_output_string($width) . '" rows="' . tep_output_string($height) . '"';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    if ( (isset($GLOBALS[$name])) && ($reinsert_value == true) ) {

  $field .= tep_output_string_protected(stripslashes($GLOBALS[$name]));

} elseif (tep_not_null($text)) {

  $field .= tep_output_string_protected($text);

}



    $field .= '</textarea>';

    return $field;
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a form hidden field
  function tep_draw_hidden_field($name, $value = '', $parameters = '') {
    $field = '<input type="hidden" name="' . tep_output_string($name) . '"';

    if (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    } elseif (isset($GLOBALS[$name])) {
      $field .= ' value="' . tep_output_string(stripslashes($GLOBALS[$name])) . '"';
    }

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    return $field;
  }

  // --------------------------------------------------------------------------------------------------------------
  // Hide form elements
  function tep_hide_session_id() {
    global $session_started, $SID;

    if (($session_started == true) && tep_not_null($SID)) {
      return tep_draw_hidden_field(tep_session_name(), tep_session_id());
    }
  }

  // --------------------------------------------------------------------------------------------------------------
  // Output a form pull down menu
  function tep_draw_pull_down_menu($name, $values, $default = '', $parameters = '', $required = false) {
    $field = '<select name="' . tep_output_string($name) . '"';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    if (empty($default) && isset($GLOBALS[$name])) $default = stripslashes($GLOBALS[$name]);

    for ($i=0, $n=sizeof($values); $i<$n; $i++) {
      $field .= '<option value="' . tep_output_string($values[$i]['id']) . '"';
      if ($default == $values[$i]['id']) {
        $field .= ' SELECTED';
      }

      $field .= '>' . tep_output_string($values[$i]['text'], array('"' => '&quot;', '\'' => '&#039;', '<' => '&lt;', '>' => '&gt;')) . '</option>';
    }
    $field .= '</select>';

    if ($required == true) $field .= TEXT_FIELD_REQUIRED;

    return $field;
  }

  // --------------------------------------------------------------------------------------------------------------
  // Creates a pull-down list of countries
  function tep_get_country_list($name, $selected = '', $parameters = '') {
    $countries_array = array(array('id' => '', 'text' => PULL_DOWN_DEFAULT));
    $countries = tep_get_countries();

    for ($i=0, $n=sizeof($countries); $i<$n; $i++) {
      $countries_array[] = array('id' => $countries[$i]['countries_id'], 'text' => $countries[$i]['countries_name']);
    }

    return tep_draw_pull_down_menu($name, $countries_array, $selected, $parameters);
  }

?>
